PRINT '-----------------------------------------------------------------------------------------------------------------'
PRINT '-- DBA_PM_ProcsPrev '
PRINT '-----------------------------------------------------------------------------------------------------------------'
IF OBJECT_ID('DBA_PM_ProcsPrev') IS NULL
BEGIN
	CREATE TABLE DBA_PM_ProcsPrev(
		Spid smallint NOT NULL,
		HostProcess int NOT NULL,
		Ecid smallint NOT NULL,
		IsActive smallint NOT NULL,
		login sysname NULL,
		status varchar(30) NULL,
		dbname sysname NULL,
		HostName varchar(128) NULL,
		Cmd varchar(16) NULL,
		appl varchar(128) NULL,
		Open_Tran smallint NULL,
		blking smallint NOT NULL,
		blkby smallint NULL,
		blklvl smallint NOT NULL,
		waittime bigint NULL,
		waittype binary(2) NULL,
		lastwaittype varchar(64) NULL,
		waitresource varchar(512) NULL,
		cpu bigint NULL,
		Physical_io bigint NULL,
		memusage int NULL,
		now datetime NOT NULL,
		login_time datetime NULL,
		last_batch datetime NULL,
		SinceLastBatch numeric(14, 3) NULL,
		sql_handle binary(20) NOT NULL,
		stmt_start int NOT NULL,
		stmt_end int NOT NULL,
		current_sp int NULL,
		curdbid smallint NULL,
		curstmt varchar(255) NULL,
		delay int NOT NULL,
		inputbuffer varchar(4000) NOT NULL
		) 
END
ELSE BEGIN
	Print 'Table already exists, performing Alters (if required)...'

	--SQL2005 Changes (255) -> (4000)
	PRINT 'Altering inputbuffer...'
	ALTER TABLE DBA_PM_ProcsPrev ALTER COLUMN inputbuffer varchar(4000) NOT NULL
	PRINT 'Altering curstmt...'
	ALTER TABLE DBA_PM_ProcsPrev ALTER COLUMN curstmt varchar(255) NULL


	-- int -> bigint
	PRINT 'Altering waittime...'
	ALTER TABLE DBA_PM_ProcsPrev ALTER COLUMN waittime bigint NULL

	PRINT 'Altering CPU...'
	ALTER TABLE DBA_PM_ProcsPrev ALTER COLUMN CPU bigint NULL

	-- numeric(10,3) -> numeric(14,3)
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='last_since')
	BEGIN
		PRINT 'Altering last_since...'
		ALTER TABLE DBA_PM_ProcsPrev ALTER COLUMN last_since numeric(14, 3) NULL
	END




	-- clprocess -> HostProcess
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='clprocess')
	  exec sp_rename 'DBA_PM_ProcsPrev.clprocess', 'HostProcess','COLUMN'
	-- active -> IsActive
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='active')
	  exec sp_rename 'DBA_PM_ProcsPrev.active', 'IsActive','COLUMN'
	-- physio -> Physical_io
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='physio')
	  exec sp_rename 'DBA_PM_ProcsPrev.physio', 'Physical_io','COLUMN'
	-- last_Since -> SinceLastBatch
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='last_since')
	  exec sp_rename 'DBA_PM_ProcsPrev.last_since', 'SinceLastBatch','COLUMN'
	-- host -> HostName
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='host')
	  exec sp_rename 'DBA_PM_ProcsPrev.host', 'HostName','COLUMN'
	-- Command -> cmd
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='Command')
	  exec sp_rename 'DBA_PM_ProcsPrev.Command', 'Cmd','COLUMN'
	-- opntrn -> Open_Tran
	if exists (select top 1 * from syscolumns where OBJECT_NAME(id)='DBA_PM_ProcsPrev' and name='opntrn')
	  exec sp_rename 'DBA_PM_ProcsPrev.opntrn', 'Open_Tran','COLUMN'

	-- bit -> smallint
	PRINT 'Altering IsActive...'
	ALTER TABLE DBA_PM_ProcsPrev ALTER COLUMN IsActive smallint NOT NULL


END
GO






