--view API into DBA_PM_WaitAndBlockMonitor
IF EXISTS (select * from sys.objects WHERE object_id = object_id('dbo.BlockAndWaitMonitor'))
BEGIN
	DROP VIEW dbo.BlockAndWaitMonitor
END;
GO
CREATE VIEW dbo.BlockAndWaitMonitor
AS
	SELECT 
		b.ObjId, b.CurrTime, b.spid, b.BlockingSpid,b.IsHeadBlocker, b.ServerName, b.DBName,b.waittime, b.wait_type, b.wait_resource, 
		b.resource_description,b.status, b.CommandType,b.cpu_ms,b.physical_io,
		DATEDIFF(ms,COALESCE(b.last_batch,b.CurrTime),b.CurrTime)AS ElapsedMS,																									--total time since request arrival
		left( SUBSTRING(b.SQLText, (b.statement_start_offset/2)+1,												--actual statement within the batch that is executing.  Is not guaranteed to always be accurate
			((CASE b.statement_end_offset WHEN -1 THEN DATALENGTH(b.SQLText)						
			ELSE b.statement_end_offset END - b.statement_start_offset)/2) + 1), 1500) AS StatementText,
		--b.StatementText,	
		b.SQLText,
		b.program_name,b.hostname,b.login_name,b.last_batch,b.open_tran,b.tran_iso_level
	FROM dbo.DBA_PM_BlockAndWaitStats b WITH (NOLOCK)
	--ORDER BY b.CurrTime desc




GO
GRANT SELECT ON dbo.BlockAndWaitMonitor TO PUBLIC;
GO
