/*
This script will 
1. delete the original "block job" 
2. Truncate the master..blocktable table and insert a "redirect record" pointing them to the SMSPHseda..DBA_PM_Blocks table
3. Truncate the SMSPHcdb..blocktable table and insert a similar "redirect record" 

22Sep2009 - Added logic to check for that SMSPHcdb database exists before issuing commands against it
*/


-----------------------------------------------------------------------------------
-- DELETE 'Monitor - Blocking Check' if it exists
-----------------------------------------------------------------------------------
DECLARE @JobID BINARY(16)  

SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name like '%Blocking Check')       

IF @JobID IS NULL
   PRINT 'Job "Monitor - Blocking Check" is not found.  No updates performed.'
ELSE 
BEGIN
  PRINT 'Deleting Job "Monitor - Blocking Check"...'
  EXECUTE msdb.dbo.sp_delete_job @job_id = @JobID
END

-----------------------------------------------------------------------------------
-- Clear-out and insert "redirect" record for Master..blocktable
-----------------------------------------------------------------------------------
if exists (select 1 from master..sysobjects where type='u' and name = 'blocktable')
BEGIN 
   truncate table  master..blocktable 
   insert into master..blocktable 
     (CurrTime, BlockedSpid, BlockingSpid,eventtype1) 
     values (getdate(),0,0,'Please use SMSPHsfu..DBA_PM; This table is no longer used')
END

if exists (select 1 from master..sysobjects where type='u' and name = 'blocktable_locks')
BEGIN 
   drop table master..blocktable_locks 
END


-----------------------------------------------------------------------------------
-- Clear-out and insert "redirect" record for SMSPHcdb..blocktable
-----------------------------------------------------------------------------------
if exists (select 1 from master..sysdatabases where name = 'SMSPHcdb')
BEGIN
   if exists (select 1 from SMSPHcdb..sysobjects where type='u' and name = 'blocktable')
   BEGIN 
      truncate table  SMSPHcdb..blocktable 
      insert into SMSPHcdb..blocktable 
        (CurrTime, BlockedSpid, BlockingSpid,eventtype1) 
        values (getdate(),0,0,'Please use SMSPHsfu..DBA_PM; This table is no longer used')
   END

   if exists (select 1 from SMSPHcdb..sysobjects where type='u' and name = 'blocktable_locks')
   BEGIN 
      drop table SMSPHcdb..blocktable_locks 
   END
END




