------------------------------------------------------------------------------
-- Step 1. Create temp table #DBA_PM_Config
------------------------------------------------------------------------------
select top 0 * into #DBA_PM_Config from DBA_PM_Config


------------------------------------------------------------------------------
-- Step 2. Populate temp table with data to be inserted/updated
------------------------------------------------------------------------------
-- SET CPUThreshold to 5% of IntervalTime
--INSERT INTO #DBA_PM_Config (ConfigSetting, ConfigValueInt)
--VALUES ('CPUThreshold', 5)

-- SET Polling Interval to 15 seconds
INSERT INTO #DBA_PM_Config (ConfigSetting, ConfigValueInt)
VALUES ('PollingInterval', 15)

-- SET Retention Days for DBA_PM data
INSERT INTO #DBA_PM_Config (ConfigSetting, ConfigValueInt)
VALUES ('RetentionDays', 7)



-- Enabling AddIns
INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_PerfCounters','ConfigValueInt indicates Polling Interval (Hours)',1)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_CaptureSpaceUsed','ConfigValueInt indicates Polling Interval (Hours)',168)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_CaptureDeadlocks','ConfigValueInt indicates Polling Interval (Hours)',8)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_IndexMetrics','ConfigValueInt indicates Polling Interval (Hours)',4);

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_PlanCache','ConfigValueInt indicates Polling Interval (Hours)',7)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_Buffers','ConfigValueInt indicates Polling Interval (Hours)',5)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_IO','ConfigValueInt indicates Polling Interval (Hours)',7)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_Purge','ConfigValueInt indicates Polling Interval (Hours)',24)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('LastPurgeRun','1/1/1980',24)

INSERT INTO #DBA_PM_Config (ConfigSetting,ConfigValueText,ConfigValueInt)
VALUES ('DBA_PM_Addin_AbandonedSpidKiller','Runs every time DBA_PM_RunAddins is called (default of 5 mins for SQL Agent job)',0)




------------------------------------------------------------------------------
-- Step 3. Insert any rows that are not in the DBA_PM_Config table
------------------------------------------------------------------------------
INSERT INTO DBA_PM_Config
  SELECT t1.*
  FROM #DBA_PM_Config t1
  LEFT OUTER JOIN DBA_PM_Config t2
  on t1.ConfigSetting = t2.ConfigSetting
  and isnull(t1.ConfigInstance,'<NULL>') = isnull(t2.ConfigInstance,'<NULL>')
  WHERE t2.ConfigSetting IS NULL


------------------------------------------------------------------------------
-- Step 4. Update existing rows that may have had data changed
------------------------------------------------------------------------------
UPDATE T2
SET ConfigValueInt = t1.ConfigValueInt
  , ConfigValueText = t1.ConfigValueText
  FROM #DBA_PM_Config t1
  INNER JOIN DBA_PM_Config t2
  on t1.ConfigSetting = t2.ConfigSetting
  and isnull(t1.ConfigInstance,'<NULL>') = isnull(t2.ConfigInstance,'<NULL>')
  WHERE (  isnull(t1.ConfigValueInt,-1010) <> isnull(t2.ConfigValueInt,-1010)
        OR isnull(t1.ConfigValueText,'<NULL>') <> isnull(t2.ConfigValueText,'<NULL>')
        )




DROP TABLE #DBA_PM_Config
GO