if exists (select 1 from sysobjects where name = 'DBA_DeadlockTracingTestProcedure' and type='p')
   drop procedure DBA_DeadlockTracingTestProcedure
GO

  
    
CREATE Procedure DBA_DeadlockTracingTestProcedure ( @Help char(1)=NULL )      
AS
BEGIN   
IF @HELP='?'  or @HELP is null
  BEGIN  
    PRINT '-- THIS STORED PROCEDURE DOES NOT ACTUALLY EXECUTE AND CREATE DEADLOCKS.  RATHER,'  
    PRINT '-- IT CONTAINS THE INSTRUCTIONS NECESSARY TO CREATE DEADLOCKS BY A MANUAL PROCESS.'
    PRINT '-- This is a 4 step process that requires 2 connections.' 
    PRINT '-- Open the body of the stored procedure to see the steps.' 
  END  
return  --CODE AFTER THE RETURN IS INTENTIONALLY DEAD CODE AND IS TO BE EXECUTED MANUALLY!!


 --STEP 1
	-- Open Connection 1 and run this SQL:
	IF OBJECT_ID('TABLE1') IS NOT NULL
	  DROP TABLE TABLE1
	CREATE TABLE table1 (id INT);
	INSERT INTO table1 VALUES (1);
    --go
	BEGIN TRAN
	UPDATE table1 SET id = 2;

 --STEP 2
	-- Open Connection 2 and run this SQL:
	IF OBJECT_ID('TABLE2') IS NOT NULL
	  DROP TABLE TABLE2
	CREATE TABLE table2 (id INT);
	INSERT INTO table2 VALUES (1);
    --go
	BEGIN TRAN
	UPDATE table2 SET id = 2;

 --STEP 3  (This step generates blocking, only)
	-- Go to Connection 1 and run this SQL:
	SELECT * FROM table2;
	
 --STEP 4  (This step causes a deadlock)
	-- Go to Connection 2 and run this SQL:
	SELECT * FROM table1;

END


GO  