IF exists (select 1 from sysobjects where name='DBA_PM_Addin_Buffers' and type='p')
   DROP procedure DBA_PM_Addin_Buffers
GO

  
CREATE Procedure DBA_PM_Addin_Buffers       
As    
BEGIN        
	set nocount on             
	    
	DECLARE @Now DATETIME , @nowprev DATETIME     , @dbname varchar(200) 
	SELECT @nowprev = MAX(Currtime) from dbo.DBA_PM_BufferStats  
	SELECT @now = GETDATE()    
	
	DECLARE @PollingInterval int
	SELECT @PollingInterval = COALESCE(ConfigValueInt,5) 
	FROM DBA_PM_Config
	WHERE ConfigSetting = 'DBA_PM_Addin_Buffers'
	
	if datediff (hh,COALESCE(@nowprev,'1/1/1980'),@now) > @PollingInterval   
	BEGIN	
		--Step 1:
		--
		DECLARE dbs CURSOR FOR 
			SELECT name 
			FROM sys.databases
			WHERE name LIKE 'SMS%'
			AND database_id <> db_id()
			AND state_desc = 'ONLINE' 
		   AND user_access_desc = 'MULTI_USER'
		   AND is_in_standby = 0 
		   ORDER BY name
		OPEN dbs 
		FETCH NEXT FROM dbs INTO @dbname 
		WHILE @@FETCH_STATUS = 0 
		BEGIN
			EXEC DBA_PM_GatherBufferData @dbname
			FETCH NEXT FROM dbs INTO @dbname 
		END
		CLOSE dbs
		DEALLOCATE dbs
		
	END;   

END
GO  