If exists (select 1 from sysobjects where name='DBA_PM_Addin_CaptureSpaceUsed' and xtype='p')
   DROP Procedure DBA_PM_Addin_CaptureSpaceUsed
GO

  
Create PROCEDURE DBA_PM_Addin_CaptureSpaceUsed  
AS   
BEGIN
SET NOCOUNT ON  
  
DECLARE @tbDatabases TABLE (DBName VARCHAR(128), IDCol INT IDENTITY(1,1))  
DECLARE @vcDBName VARCHAR(128)  
DECLARE @CurrTime DATETIME  , @nowprev DATETIME
select @CurrTime=GETDATE()   
  
declare @i INT  
SELECT @i=1  

--only run this once per week     
SELECT @nowprev = MAX(CurrTime) from dbo.DBA_PM_DriveFreeSpace    

DECLARE @PollingInterval int
SELECT @PollingInterval = COALESCE(ConfigValueInt,168) 
FROM DBA_PM_Config
WHERE ConfigSetting = 'DBA_PM_Addin_CaptureSpaceUsed'                  
	                                          
if datediff (dd,COALESCE(@nowprev,'1/1/1980'),@CurrTime) > @PollingInterval                      
BEGIN   
	--PRINT 'Capturing FreeSpace for Drives (or Mount Points) on Database Server...'  
	EXEC SEDA_DriveFreeSpace @CurrTime  
	
	DECLARE dbs CURSOR FOR 
		SELECT name 
		FROM sys.databases 
		WHERE name NOT IN ('tempdb','model','master')
		AND state_desc = 'ONLINE' 
	   AND user_access_desc = 'MULTI_USER'
	   AND is_in_standby = 0 
		ORDER BY name desc
	OPEN dbs
	FETCH NEXT FROM dbs INTO @vcDBName
	WHILE @@FETCH_STATUS = 0 
	BEGIN
	
		--PRINT ''  
		PRINT 'Processing Database '+@vcDBName+'...'  
		PRINT '  Executing SEDA_SpaceUsedByTables '  
		EXEC SEDA_SpaceUsedByTables @vcDBName,@CurrTime  
		PRINT '  Executing SEDA_SpaceUsedByFiles '  
		EXEC SEDA_SpaceUSedByFiles @vcDBName,@CurrTime  
		PRINT '  Executing SEDA_SpaceUsedByDatabase '  
		EXEC SEDA_SpaceUsedByDatabase @vcDBName,@CurrTime  
	
	
		FETCH NEXT FROM dbs INTO @vcDBName
	END;
	CLOSE dbs
	DEALLOCATE dbs
	  
END;
END;
GO
  
