IF EXISTS (select 1 from sysobjects where name='DBA_PM_Addin_PURGE' and xtype='P')
   DROP PROCEDURE DBA_PM_Addin_PURGE
GO

CREATE  PROC DBA_PM_Addin_PURGE                         
AS                          
BEGIN        
	SET NOCOUNT ON                  
	DECLARE @iRetentionDays int, @dtRetentionDate datetime, @now datetime, @nowprev datetime
	
	SELECT @now = GETDATE()         
	
	SELECT @nowprev = convert(datetime,ConfigValueText) 
	FROM DBA_PM_Config 
	WHERE ConfigSetting = 'LastPurgeRun'
	--SELECT @nowprev
	
	DECLARE @PollingInterval int
	SELECT @PollingInterval = COALESCE(ConfigValueInt,24) 
	FROM DBA_PM_Config
	WHERE ConfigSetting = 'DBA_PM_Addin_PURGE'                      
	
	--SELECT @PollingInterval        
	--select datediff (hh,COALESCE(@nowprev,'1/1/1980'),@now)               
	                      
	if datediff (hh,COALESCE(@nowprev,'1/1/1980'),@now) > @PollingInterval                      
	BEGIN                      
	   Select @iRetentionDays = ConfigValueInt from DBA_PM_Config WHERE ConfigSetting='RetentionDays'                      
	   Select @dtRetentionDate = dateadd(dd,0-ISNULL(@iRetentionDays,7),@now) 
	   --Select dateadd(dd,0-ISNULL(7,7),GETDATE())                        
	   
	   
	   --add tables to purge here:                     
	   DELETE from dbo.DBA_PM_BlockAndWaitStats WHERE CurrTime < @dtRetentionDate  
	   DELETE from DBA_PM_PerfCounters  WHERE Currtime < @dtRetentionDate  
	   DELETE from DBA_PM_DriveFreeSpace  WHERE Currtime < @dtRetentionDate 
	   DELETE from DBA_PM_SpaceUsedByTables  WHERE Currtime < @dtRetentionDate 
	   DELETE from DBA_PM_SpaceUsedByFiles  WHERE Currtime < @dtRetentionDate 
	   DELETE from DBA_PM_SpaceUsedByDatabase  WHERE Currtime < @dtRetentionDate   
	   DELETE from DBA_PM_DeadlockSnapshot WHERE Currtime < @dtRetentionDate  
	   DELETE from DBA_PM_DeadlockSnapshotCorruptedBuffer  WHERE Currtime < @dtRetentionDate 
	   DELETE from DBA_PM_IndexBlocking  WHERE Currtime < @dtRetentionDate 
	   DELETE from DBA_PM_PossibleBadIndexes WHERE Currtime < @dtRetentionDate 
	   DELETE from DBA_PM_AdHocPlanCacheBloat WHERE Currtime < @dtRetentionDate
	   DELETE from DBA_PM_PlanCacheMetrics WHERE Currtime < @dtRetentionDate
	   DELETE from DBA_PM_PlanTypeStats WHERE Currtime < @dtRetentionDate
	   DELETE from DBA_PM_BufferStats WHERE Currtime < @dtRetentionDate
	   DELETE from DBA_PM_IOStalls WHERE Currtime < @dtRetentionDate
	   
	   UPDATE DBA_PM_Config SET ConfigValueText = @now WHERE ConfigSetting = 'LastPurgeRun'
	   
	END    
            
END;
GO                      
