IF EXISTS (select 1 from sysobjects where name='DBA_PM_RunAddins' and xtype='P')
   DROP PROCEDURE DBA_PM_RunAddins
GO

CREATE  PROC DBA_PM_RunAddins                         
AS                          
BEGIN                          
	--------------------------------------------------------------------------------------------                          
	--------------------------------------------------------------------------------------------                          
	--                          
	-- Run Add-in Stored Procedures ( All SPs w/ name DBA_PM_Addin% with ConfigValInt = 1)              
	--                          
	--------------------------------------------------------------------------------------------                          
	--------------------------------------------------------------------------------------------                          
	declare @tbAddinSP TABLE (SPName VARCHAR(128), IDCol INT IDENTITY(1,1))      
	declare @i int                  
	declare @iSPCount INT    
	     
	declare @CurrSP VARCHAR(128)              
	              
	insert into @tbAddinSP (SPName)               
	  select o.name               
	  from sysobjects o        
	  inner join dba_pm_config c        
	  on o.name = c.configsetting               
	  where o.type='p'               
	  and o.name like 'dba_pm_addin%'         
	            
	              
	Select @iSPCount=@@ROWCOUNT              
	select @i=1              
	while @i <= @iSPCount              
	BEGIN              
	   select @CurrSP=SPName from @tbAddinSP where IDCOl=@i     
	   PRINT 'Executing ' + @CurrSP         
	   Exec ('Exec '+@CurrSP)               
	   select @i=@i+1              
	END                        
END;
GO                      
