If exists (select 1 from sysobjects where name='SEDA_DriveFreeSpace' and xtype='p')
   DROP Procedure SEDA_DriveFreeSpace
GO


create  PROCEDURE SEDA_DriveFreeSpace (@CurrTime datetime=NULL)
AS

SET NOCOUNT ON

IF @CurrTime IS NULL SELECT @CurrTime =getdate()

CREATE TABLE #DriveMountPoints(Drive char(1), MountPoint varchar(250), FreeSpace BIGINT, IDCol INT IDENTITY(1,1))
CREATE TABLE #dir_output (c1 varchar(1000))

CREATE TABLE #FixedDrives
(DriveLetter CHAR(1)
,FreeMB int
)
INSERT INTO #FixedDrives EXEC master..xp_fixeddrives

DECLARE @DriveLetter char(1)
DECLARE @DriveLetterMax char(1)

SELECT @DriveLetterMax = MAX(DriveLetter) 
, @DriveLetter = MIN(DriveLetter) 
FROM #FixedDrives

WHILE @DriveLetter <= @DriveLetterMax
BEGIN 
   insert into #dir_output Exec ('Master..xp_cmdshell ''dir '+@DriveLetter+':''')

   INSERT INTO #DriveMountPoints (Drive, MountPoint)
     select @DriveLetter,RTRIM(LTRIM(SUBSTRING(c1,charindex('<JUNCTION>',c1)+10,99))) from #dir_output where c1 like '%<JUNCTION>%'
  
   SELECT @DriveLetter=MIN(DriveLetter) 
     FROM #FixedDrives
     WHERE DriveLetter > @DriveLetter

   TRUNCATE TABLE #dir_output
END


IF NOT EXISTS(select 1 from #DriveMountPoints)
BEGIN
   INSERT INTO DBA_PM_DriveFreeSpace (Currtime, ServerName,DriveLetter, FreeMB)
     SELECT @CurrTime, @@SERVERNAME,DriveLetter, FreeMB 
     FROM #FixedDrives
END -- NOT EXISTS(select 1 from #DriveMountPoints)
ELSE BEGIN
   DECLARE @MountPoint varchar(100)
   DECLARE @FreeSpace BIGINT

   DECLARE @iMaxIDCol int
   DECLARE @i int
   SELECT @iMaxIDCol = MAX(IDCol) from #DriveMountPoints
   SET @i=1

   WHILE @i <= ISNULL(@iMaxIDCol,0)
   BEGIN
      select @DriveLetter=Drive
        , @MountPoint=MountPoint
        FROM #DriveMountPoints
        WHERE IDCol=@i

      insert into #dir_output Exec ('Master..xp_cmdshell ''fsutil volume diskfree '+@DriveLetter+':'+@MountPoint+'''')

      SELECT @FreeSpace = convert(bigint,substring(c1,charindex(':',c1)+1,99)) 
        from #dir_output
        where c1 like '%Total # of avail free bytes%'

      UPDATE #DriveMountPoints
        SET FreeSpace=@FreeSpace
        WHERE IDCol=@i

      SELECT @i=@i+1
      TRUNCATE TABLE #dir_output
   END -- @i <= ISNULL(@iMaxIDCol,0)

   INSERT INTO DBA_PM_DriveFreeSpace (CurrTime, SERVERNAME,DriveLetter, MountPoint, FreeMB)
     SELECT @CurrTime, @@SERVERNAME,Drive, MountPoint, FreeSpace/1024
     from #DriveMountPoints

END -- EXISTS(select 1 from #DriveMountPoints)


drop table #FixedDrives
drop table #DriveMountPoints
drop table #dir_output


GO