
If exists (select 1 from sysobjects where name='SEDA_SpaceUSedByFiles' and xtype='p')
   DROP Procedure SEDA_SpaceUSedByFiles
GO

CREATE  PROCEDURE SEDA_SpaceUSedByFiles (@DBName varchar(100), @CurrTime datetime=NULL)
AS 
SET NOCOUNT ON
IF @CurrTime IS NULL SELECT @CurrTime =getdate()

Create table #ShowFileStats
(Fileid smallint
,FileGroup smallint
,TotalExtents int
,UsedExtents int
,Name varchar(200)
,FileName varchar(400)
)

INSERT INTO #ShowFileStats exec ('use '+@DBName+' DBCC showfilestats')

DECLARE @SQL varchar(4000)
SELECT @SQL='
insert into DBA_PM_SpaceUsedByFiles
(CurrTime, DBName, Fileid
,Autogrow
, FileGroup, Name, FileName, SpaceAllocated, SpaceUsed, SpaceFree, ServerName)
select '''+CONVERT(VARCHAR,@CurrTime,121)+''','''+@DBName+''',t1.Fileid
,case f.status & 0x100000 
   when 0x100000 then convert(nvarchar(15), f.growth) + N''%''  
   else convert(nvarchar(15), convert (bigint, f.growth) * 8) + '' KB'' 
 end  --Autogrow
, t1.FileGroup, t1.Name, t1.FileName, t1.TotalExtents/16, t1.UsedExtents/16, (t1.TotalExtents-t1.UsedExtents)/16
, ''' + @@SERVERNAME + '''
FROM #ShowFileStats t1
INNER JOIN '+@DBName+'..sysfiles f
ON t1.fileid = f.fileid'

exec(@SQL)

drop table #ShowFileStats

--------------------------------------------------
-- Logic to join to FreeSpace on Drive(mountPoint)
--------------------------------------------------
UPDATE SU
   SET DriveMP=FS.DriveLetter+':\'+ISNULL(FS.MountPoint,'')
   ,   DriveMPFree=FS.FreeMB
from DBA_PM_SpaceUsedByFiles SU
inner join DBA_PM_drivefreespace FS
ON charindex(FS.DriveLetter+':\'+ISNULL(FS.MountPoint,''),su.filename) > 0

GO


