If exists (select 1 from sysobjects where name='SEDA_SpaceUsedByTables' and xtype='p')
   DROP Procedure SEDA_SpaceUsedByTables
GO


CREATE PROCEDURE SEDA_SpaceUsedByTables (@DBName VARCHAR(100), @CurrTime datetime=NULL)
AS
SET NOCOUNT ON

IF @CurrTime IS NULL SELECT @CurrTime =getdate()

if object_id(N'tempdb..#TableSizes') is not null 
  drop table #TableSizes
if object_id(N'tempdb..#TableList') is not null 
  drop table #TableList
if object_id(N'tempdb..#MaxPKForTable') is not null 
  drop table #MaxPKForTable
 
 
CREATE TABLE #TableSizes
  (
    TableName nvarchar(128)
  , RowCnt char(11)    
  , ReservedSpace varchar(18) 
  , DataSpace varchar(18)    
  , IndexSpace varchar(18)   
  , UnusedSpace varchar(18)  
  ) 

CREATE TABLE #TableList (TableName varchar(200), IDCol int identity(1,1))

Create TABLE #MaxPKForTable(TableName varchar(200), PKField varchar(100), MaxPKVal BIGINT)

DECLARE @iMaxID INT
DECLARE @i INT 
DECLARE @TableName varchar(256) 

DECLARE @SQL VARCHAR(MAX)
SELECT @SQL='
INSERT INTO #TableList
SELECT ss.name + ''.'' + so.name AS TableName
FROM '+@DBName+'.sys.objects so
INNER JOIN '+@DBName+'.sys.schemas ss
ON so.schema_id = ss.schema_id 
WHERE object_id > 100
AND type_desc = ''USER_TABLE''
ORDER BY 1
'
exec (@SQL) 
SELECT @iMaxID = MAX(IDCol) from #TableList 

SELECT @i=1
WHILE @i <= @iMaxID
BEGIN
   SELECT @TableName = TableName FROM #TableList WHERE IDCol=@i
   --PRINT @TableName
   select @SQL='INSERT INTO #TableSizes EXEC '+@DBName+'..sp_spaceused @objname = '''+@TableName+''''
   --PRINT @SQL
   BEGIN TRY
	EXEC(@SQL) 
   --PRINT @SQL
   END TRY
   BEGIN CATCH
		PRINT 'Failed on this:' + @SQL
   END CATCH
   SELECT @i = @i+1
END

 
update #TableSizes set UnusedSpace = replace(UnusedSpace,' KB','')
alter table #TableSizes alter column UnusedSpace int

update #TableSizes set ReservedSpace = replace(ReservedSpace,' KB','')
alter table #TableSizes alter column ReservedSpace int

update #TableSizes set DataSpace = replace(DataSpace,' KB','')
alter table #TableSizes alter column DataSpace int

update #TableSizes set IndexSpace = replace(IndexSpace,' KB','')
alter table #TableSizes alter column IndexSpace int

-----------------------------------------------------------------------------
-- Logic added to get MAX(Primary Key Value) for each table
-----------------------------------------------------------------------------
--Create Table #PK (TableName varchar(100), Name varchar(300), RowNum INT)
--SELECT @SQL='
--INSERT INTO #PK (TableName, Name, RowNum)
--	select t.name as TableName, c.name, ROW_NUMBER() OVER (partition by i.object_id order by ic.index_column_id) as RowNum
--	from '+@DBName+'.sys.indexes i
--	inner join '+@DBName+'.sys.tables t
--	on i.object_id = t.object_id
--	inner join '+@DBName+'.sys.index_columns ic
--	on i.object_id=ic.object_id 
--	and i.index_id=ic.index_id 
--	inner join '+@DBName+'.sys.columns c
--	on ic.object_id=c.object_id 
--	and ic.index_column_id = c.column_id
--	where is_primary_key=1
--	and c.system_type_id IN (56,127)
--	'
--EXEC(@SQL)

--SET @SQL=NULL                  
--SELECT  @SQL = ISNULL(@SQL + '
--  ' + 'INSERT INTO #MaxPKForTable select '''+TableName+''','''+Name+''',MAX('+name+') from '+@DBName+'..'+TableName,
--  'INSERT INTO #MaxPKForTable select '''+TableName++''','''+Name+''',MAX('+name+') from '+@DBName+'..'+TableName
--  )
--FROM #pk where RowNum=1
--exec (@SQL)


INSERT INTO DBA_PM_SpaceUsedByTables
  (CurrTime,DBName,ServerName, TableName, RowCnt, ReservedSpace, DataSpace, IndexSpace, UnusedSpace, PKField, MaxPKVal)
  SELECT @CurrTime
  , @DBName
  , @@SERVERNAME
  , t1.TableName
  , t1.RowCnt
  , t1.ReservedSpace
  , t1.DataSpace
  , t1.IndexSpace
  , t1.UnusedSpace
  , t2.PKField
  , t2.MaxPKVal
  FROM #TableSizes t1
  left outer join #MaxPKForTable t2
  on t1.TableName = t2.TableName
  ORDER BY t1.TableName 

GO

